package net.avicus.api.events;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class LeapEventFactory implements org.bukkit.event.Listener
{
	public LeapEventFactory(JavaPlugin p)
	{
		p.getServer().getPluginManager().registerEvents(this, p);
	}

	@EventHandler
	public void login(PlayerJoinEvent e)
	{
		GamerJoinEvent event = new GamerJoinEvent(e.getPlayer());
		Bukkit.getServer().getPluginManager().callEvent(event);
	}

	@EventHandler
	public void damage(EntityDamageEvent e)
	{
		if (!(e.getEntity() instanceof Player)) return;

		PlayerDamageEvent event = new PlayerDamageEvent(e.getCause(), (Player)e.getEntity(), e);
		Bukkit.getServer().getPluginManager().callEvent(event);
	}

	@EventHandler // Not sure if this is really the right event..
	public void move(PlayerMoveEvent e)
	{
		if (!e.getPlayer().hasPermission("leap.use")) return;
		Location bf = e.getFrom();
		bf.setY(bf.getY() - 1);
		Block f = e.getPlayer().getWorld().getBlockAt(bf);
		if (f.getType() != Material.AIR) return;
		Location bt = e.getTo();
		bt.setY(bt.getY() - 1);
		Block t = e.getPlayer().getWorld().getBlockAt(bt);
		if (t.getType() == Material.AIR) return;
		PlayerOnGroundEvent event = new PlayerOnGroundEvent(e.getPlayer());
		Bukkit.getServer().getPluginManager().callEvent(event);
	}
}
