package net.avicus.api.events;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;

public class PlayerDamageEvent extends Event implements Cancellable
{
	private static final HandlerList handlers = new HandlerList();
	private EntityDamageEvent parent = null;
	private boolean cancelled = false;
	private DamageCause why = null;
	private Player target = null;

	public PlayerDamageEvent(DamageCause w, Player t, EntityDamageEvent p)
	{
		this.parent = p;
		this.target = t;
		this.why = w;
	}

	public boolean isCancelled()
	{
		return this.cancelled;
	}

	public void setCancelled(boolean set)
	{
		if (set == this.cancelled) return;

		this.cancelled = set;
		this.parent.setCancelled(set);
	}

	public Player getTarget()
	{
		return this.target;
	}

	public DamageCause getCause()
	{
		return this.why;
	}

	public HandlerList getHandlers()
	{
		return handlers;
	}

	public static HandlerList getHandlerList()
	{
		return handlers;
	}
}
