package net.avicus.api.utils;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang.Validate;
import org.bukkit.plugin.java.JavaPlugin;

public class Config
{
	private JavaPlugin a = null;

	public Config(JavaPlugin plugin)
	{
		Validate.notNull(plugin, "Config cannot accept a null plugin!!");
		this.a = plugin;
		File configFile = new File("plugins/" + this.a.getName() + "/config.yml");
		if (!configFile.exists()) this.a.saveDefaultConfig();
		this.a.getConfig();
		this.a.getConfig().options().copyDefaults(true);
	}

	public List<String> getStringList(String path)
	{
		Validate.notNull(this.a, "Config cannot get a value from a null plugin!!");

		ArrayList<String> ret = (ArrayList<String>) this.a.getConfig().getStringList(path);
		return (ret == null) ? null : ret;
	}

	public Double getDouble(String path)
	{
		Validate.notNull(this.a, "Config cannot get a value from a null plugin!!");

		Double ret = this.a.getConfig().getDouble(path, 0);
		return ret;
	}
}
