package net.avicus.api.utils;

import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class Gamer
{
	private Player player = null;

	private Gamer(Player p)
	{
		this.player = p;
	}

	public boolean hasPermission(String p)
	{
		if (this.player == null) return false;
		return (this.player.hasPermission(p));
	}

	public void sendMessage(String s)
	{
		if (this.player == null) return;
		this.player.sendMessage(Chat.applyColor(s));
	}

	public String getName()
	{
		if (this.player == null) return "";
		return this.player.getName();
	}

	public void setAllowFlight(boolean set)
	{
		if (this.player == null) return;
		if (this.player.getAllowFlight() == set) return;
		this.player.setAllowFlight(set);
	}

	public static Gamer get(CommandSender s)
	{
		if (!(s instanceof Player)) return null;
		Player pl = null;

		for (Player p : Bukkit.getOnlinePlayers())
		{
			if (p.getName().equals(s.getName())) pl = (Player)s;
		}

		if (pl == null) return null;
		return new Gamer(pl);
	}
}
